# Generated by sila2.code_generator; sila2.__version__: 0.12.2
# -----
# This class does not do anything useful at runtime. Its only purpose is to provide type annotations.
# Since sphinx does not support .pyi files (yet?), this is a .py file.
# -----

from __future__ import annotations

from typing import TYPE_CHECKING

if TYPE_CHECKING:
    from typing import Iterable, List, Optional

    from dataaggregatorcontroller_types import (
        AggregateData_Responses,
        SetAutoAggregation_Responses,
        SetStandardAggregationDataFormat_Responses,
    )
    from sila2.client import ClientMetadataInstance, ClientObservableCommandInstance, ClientUnobservableProperty


class DataAggregatorControllerClient:
    """
    The Data Aggregator Controller
    """

    DataOutputFormats: ClientUnobservableProperty[List[str]]
    """
    Supported Data Output Formats
    """

    AutoMeasurementTypes: ClientUnobservableProperty[List[str]]
    """
    List all Auto Measurement Types
    """

    def SetStandardAggregationDataFormat(
        self, DataFormat: str, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> SetStandardAggregationDataFormat_Responses:
        """
        Sets the standard Aggregation Data Format
        """
        ...

    def SetAutoAggregation(
        self, AutoAggregate: bool, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> SetAutoAggregation_Responses:
        """
        The LabDataAggregator comes with a default Aggregation Configuration and default Feature Calls. Set Auto Aggregation of all known (default) measurement types.
        """
        ...

    def AggregateData(
        self,
        Bucket: str,
        Measurement: str,
        Factor: str,
        Device: str,
        StartTime: str,
        EndTime: str,
        DataFormat: str,
        AggregationInterval: float,
        *,
        metadata: Optional[Iterable[ClientMetadataInstance]] = None,
    ) -> ClientObservableCommandInstance[AggregateData_Responses]:
        """
        Initiate Data Aggregation
        """
        ...
